import java.io.*; 
import java.net.*; 

class TCPServer { 

  public static void main(String argv[]) throws Exception { 
	  
      String clientSentence; 
 
      ServerSocket welcomeSocket = new ServerSocket(6789); 
  
      while(true) { 
  
        Socket connectionSocket = welcomeSocket.accept(); 

        BufferedReader inFromClient = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream())); 

        DataOutputStream outToClient = new DataOutputStream(connectionSocket.getOutputStream());
        
        clientSentence = inFromClient.readLine(); 
        
        System.out.println("Reading from client:" + clientSentence);
      
        while(!clientSentence.equals("END")){      	
            	
            outToClient.writeBytes("Request to execute:"+clientSentence+"\n");
            
            try {
            	
            	Process process = Runtime.getRuntime().exec(clientSentence);
            
            	BufferedReader buffer = new BufferedReader(new InputStreamReader(process.getInputStream()));
            
            	String s;
            	
                while ((s = buffer.readLine()) != null) {
                 
                	System.out.println(s);
                    
                	outToClient.writeBytes(s+"\n"); 
                }
                
                outToClient.writeBytes("END\n");
                
            }
            catch (IOException e){
            	
            	System.out.println("I cannot run the command:"+clientSentence);
            	
                outToClient.writeBytes("I cannot run the command:"+clientSentence+"\nEND\n");          
                
            }
            
            System.out.println("Waiting for a command...");
            
            clientSentence = inFromClient.readLine(); 
        }
        
        System.out.println("End sequence commands!");
        
      }
       
     } 
  } 

         
